#include <AdvancedRemote.h>
#include <iPodSerial.h>
#include <SimpleRemote.h>

#define SWIPOD 4
#define V0 5
#define V1 6
#define V2 7
#define V3 8
#define S0 A3 //Sinistra
#define S1 A4 //Centrale
#define S2 A5 //Destra
#define T_RESET  400 //1000ms valori moltiplicati x 5
#define T_HOLD_MAX 200 //1000ms
#define T_HOLD_MIN 200  //350ms hold sullo stesso tasto
#define T_HOLD_MIN2 10  //50ms hold almeno sul primo tasto per passare ql secondo. alzando il valore si eliminano gli artefatti.
#define LED 10
#define LEDDOWN 11
#define SWOPENCLOSE 9

SimpleRemote sr;


int volume = 7;
int count = 0;
int last = -1;
int curr = -1;
int ssx;
int scx;
int sdx;
int alreadyClickedPause = 0;



int val= 0;
int brightness = 0; //luminosità del led
int brightnessdown = 0; //luminosità del led inferiore
int fadein = 2; //incremento luminosità del led (+ alto + veloce)
int fadeout = 15; //decremento luminosità del led (+ alto + veloce)


void setup(){
  pinMode(SWOPENCLOSE, INPUT);
  pinMode(SWIPOD, INPUT);
  pinMode(S0, INPUT);
  pinMode(S1, INPUT);
  pinMode(S2, INPUT);
  pinMode(V0, OUTPUT);
  pinMode(V1, OUTPUT);
  pinMode(V2, OUTPUT);
  pinMode(V3, OUTPUT);
  pinMode(LED, OUTPUT);
  pinMode(LEDDOWN, OUTPUT);
  
  digitalWrite(SWOPENCLOSE, HIGH);
  
  Serial.begin(9600);
  
  incrementaVolume(); 
}

void playPausa(){
    sr.sendPlay();
    delay(50);      
    sr.sendButtonReleased();
    delay(50);
    sr.loop();
}

void nextTraccia(){
  sr.sendSkipForward();
  delay(50);
  sr.sendButtonReleased();sr.loop();
}

void prevTraccia(){
  sr.sendSkipBackward();
  delay(50);
  sr.sendButtonReleased();
  sr.loop();
}

void incrementaVolume(){
  if(volume<15){
    volume++;
    digitalWrite(V0, bitRead(volume, 0));
    digitalWrite(V1, bitRead(volume, 1));
    digitalWrite(V2, bitRead(volume, 2));
    digitalWrite(V3, bitRead(volume, 3));
    //Serial.println("Volume+"); //OK Funz
  }
}

void decrementaVolume(){
  if(volume>0){
    volume--;
    digitalWrite(V0, bitRead(volume, 0));
    digitalWrite(V1, bitRead(volume, 1));
    digitalWrite(V2, bitRead(volume, 2));
    digitalWrite(V3, bitRead(volume, 3));
  }
}

void loop(){
  val = digitalRead (SWOPENCLOSE) ;
  if (val == HIGH){ //Se SWOPENCLOSE alias BUTTON è aperto allora lo schermo è chiuso e si spegne (intyernally pulled up)
    analogWrite (LED, brightness);
    if (brightness < 255)
      brightness = brightness + fadein;
    else  brightness = 255; 
                       
    analogWrite (LEDDOWN, brightnessdown);
    if (brightnessdown > 0)
      brightnessdown = brightnessdown - fadeout;
    
    if (brightnessdown <= 0)
      brightnessdown = 0;      
    
    delay (15);// spegnimento
    count = 0;
    last = -1;    
  }
  else{
    analogWrite (LED, brightness);
  if (brightness > 0)
    brightness = brightness - fadeout;
  if (brightness <= 0)
    brightness = 0;      
                           
  analogWrite (LEDDOWN, brightnessdown);
  
  if (brightnessdown < 255)
    brightnessdown = brightnessdown + fadein ;
  else  brightnessdown = 255; 
  
    count++;
    ssx = !digitalRead(S0);
    scx = !digitalRead(S1);
    sdx = !digitalRead(S2);
    
    if(ssx == 0){
      alreadyClickedPause = 0;
    }
    
    delay(5);
    if(ssx || scx || sdx){ //Se un sensore rileva la presenza
      if(last >= 0){
        last = curr; 
      }
      if(ssx){ //Se sinistra
        curr = 0;
      }
      if(scx){  //Se centro
        curr = 1;
      }
      if(sdx){ //Se destra
        curr = 2;
      }
      
      if(last < 0){ //Se prima non è stato rilevato nulla
        last = curr;
      }
      
      else{ //Se entro TRESET è stato premuto un tasto
        if(last == 0 && curr == 0 && count > T_HOLD_MIN && alreadyClickedPause == 0){ //Da sensore 0 a sensore 0  && count < T_HOLD_MAX
          playPausa();
          count = 0;
          last = -1;
          alreadyClickedPause = 1;
        }
        if(last == 1 && curr == 1 && count > T_HOLD_MIN){ //Da sensore 1 a sensore 1
          decrementaVolume();
          count = 0;
          last = -1;
        }      
        if(last == 1 && curr == 2 && count > T_HOLD_MIN2){ //Da sensore 1 a sensore 2
          nextTraccia();
          last = 0;
          count = 0;
        }
  
        if(last == 2 && curr == 1 && count > T_HOLD_MIN2){ //Da sensore 2 a sensore 1
          prevTraccia();
          last = 0;
          count = 0;
        }
        
        if(last == 2 && curr == 2 && count > T_HOLD_MIN){ //Da sensore 2 a sensore 2
          incrementaVolume();
          count = 0;
          last = -1;
        }    
      }
    }
    
    if(count > T_RESET){
      count = 0;
      last = -1;
    }
  }
}
